function rand_int(min, max) {
	min = Math.ceil(min);
	max = Math.floor(max);

	return Math.floor(Math.random() * (max - min + 1) + min);
}

function rand_element(array) {
	return array[rand_int(0, array.length - 1)];
}

function getOS() {
	var userAgent = window.navigator.userAgent,
		platform = window.navigator?.userAgentData?.platform || window.navigator.platform,
		macosPlatforms = ["Macintosh", "MacIntel", "MacPPC", "Mac68K"],
		windowsPlatforms = ["Win32", "Win64", "Windows", "WinCE"],
		iosPlatforms = ["iPhone", "iPad", "iPod"],
		os = null;

	if (macosPlatforms.indexOf(platform) !== -1) os = "Mac OS";
	else if (iosPlatforms.indexOf(platform) !== -1) os = "iOS";
	else if (windowsPlatforms.indexOf(platform) !== -1) os = "Windows";
	else if (/Android/.test(userAgent)) os = "Android";
	else if (/Linux/.test(platform)) os = "Linux";

	return os;
}

const os = getOS();

function toggle_sidepanel(event, id) {
	event.preventDefault(); // prevent redirect to an empty url (example.com/#)

	const sidepanel = document.getElementById(id);

	if (sidepanel.style.left == "-25%" || !sidepanel.style.left)
		sidepanel.style.left = "0%";
	else if (sidepanel.style.left == "0%")
		sidepanel.style.left = "-25%";
}

let n_offset = 0;

function notify(text = "Lorem ipsum dolor sit amet", type = null, time = 3000) {
	let notification = document.createElement("div");
	notification.innerHTML = text;
	document.body.append(notification);

	notification.classList.add("notification");

	if (type === true)
		notification.classList.add("notification-positive");
	else if (type === false)
		notification.classList.add("notification-negative");

	$(notification).animate({ top: n_offset });
	n_offset += $(notification).height() + 48;

	setTimeout(() => {
		n_offset -= $(notification).height() + 48;
		notification.remove();
	}, time);
}

function copy(content, textToNotify = "Copied to clipboard!", type, time) {
	navigator.clipboard.writeText(content);
	notify(textToNotify, type, time);

	return false; // prevent the context menu from being opened
}

function redirect(url) {
	$("body").fadeOut(300, function () {
		window.location = url;
	});

	return false;
}

$(function () {
	$("a").on("click", function (e) {
		if (this.attr("href") === "/#" || this.attr("href") === "#") return;

		e.preventDefault();

		$link = $(this).attr("href");

		$("body").fadeOut(300, function () {
			window.location = $link;
		});
	});

	document.body.addEventListener("htmx:afterSettle", function (evt) {
		$("body").fadeIn(300);
	});
});
